# program GrowthFunctions

#install.packages("xlsx")       # read excel files
#install.packages("mod")        # linear regression
#install.packages("minpack.lm") #non-linear regression
install.packages("tidyverse")

# Verify the package is installed.
any(grepl("xlsx",installed.packages()))
any(grepl("mod",installed.packages()))
any(grepl("minpack.lm",installed.packages()))

# change workspace
setwd ("C:\\Users\\Margarida\\Dropbox\\2_Ensino\\2Ciclo-MRF_2019-2020\\Aulas_R\\Aula1\\")

# Load the library into R workspace.
library("xlsx")
GrowthData<-read.xlsx("FamiliesOfGrowthCurves.xlsx", header= TRUE, sheetIndex = 1)

# print(GrowthData)
head(GrowthData,n=20)

summary(GrowthData)

plot(GrowthData$t,GrowthData$hdom)

library(tidyverse)
ggplot(GrowthData) +
  geom_line(aes(x=t,y=hdom,color=id_stand))

id_stand <- (GrowthData$id_stand)
levels (id_stand)
# Sort data
GrowthData<-GrowthData[order(GrowthData$id_stand,GrowthData$t),]

# Build the data pairs
GrowthData$t2<-NA #creates a column of null data
GrowthData$hdom2<-NA
for(i in 1:(nrow(GrowthData)-1)){
  if(GrowthData[i,"id_stand"]==GrowthData[i+1,"id_stand"]){
    GrowthData[i,"t2"]<-GrowthData[i+1,"t"]
    GrowthData[i,"hdom2"]<-GrowthData[i+1,"hdom"]
  }
}

head(GrowthData,n=20)

# exclunding lines with the NA values
GrowthData <- na.exclude(GrowthData)

head(GrowthData,n=20)

Lundqvist_k <- nls(hdom2~A*(hdom/A)**(t/t2)**m,data=GrowthData,start=list(A=1000,m=1))
print(summary(Lundqvist_k))
Lundqvist_k.s <- summary(Lundqvist_k)
res <- Lundqvist_k.s$residuals
hdomest <- predict(Lundqvist_k)

cor(GrowthData$hdom,hdomest)

plot(hdomest,res)
abline(a=0,b=0)

qqnorm(res,pch=1)
qqline(res,col="red",lwd=2)



