# program FitPlotGrowthFunction

install.packages("xlsx")       # read excel files
install.packages("mod")        # linear regression
install.packages("minpack.lm") #non-linear regression

# Verify the package is installed.
any(grepl("xlsx",installed.packages()))
any(grepl("mod",installed.packages()))
any(grepl("minpack.lm",installed.packages()))

# change workspace
setwd ("C:\\Users\\Margarida\\Dropbox\\2_Ensino\\2Ciclo-MRF_2019-2020\\Aulas_R\\Aula1\\")

# Load the library into R workspace.
library("xlsx")

Data<-read.xlsx("PlotVolumeData.xlsx", header= TRUE, sheetIndex = 1)

print(Data)

plot(Data$t,Data$V)

Lundqvist <- nls(V~A*exp(-k*(1/t)**m),data=Data,start=list(A=1000,k=10,m=1))
print(summary(Lundqvist))
Lundqvist.s <- summary(Lundqvist)
res <- Lundqvist.s$residuals
Vest <- predict(Lundqvist)

print (res)
print(Vest)

cor(Data$V,Vest)

plot(Data$t,Data$V)
lines(Data$t,Vest,lty=2,col="red",lwd=2)

plot(Vest,res)
abline(a=0,b=0)

qqnorm(res,pch=1)
qqline(res,col="red",lwd=2)

